#include "complex_number.hpp"

#include <iostream>

using namespace std;

template<typename _Tp> void printComplex(const complex<_Tp>& z) {
  cout << z.getReal() << " + " << z.getImg() << "i" << endl;
}
int main() {
  complex<int> cpx1, cpx2(1, 3);
  //expect 0 + 0i
  printComplex(cpx1);
  complex<int> cpx1_copy(cpx1);
  //expect 0 + 0i
  printComplex(cpx1_copy);
  cpx1_copy = 1;
  //expect 1 + 0i
  printComplex(cpx1_copy);
  cpx1 += cpx2;
  //expect 1 + 3i
  printComplex(cpx1);
  cpx1 += 3;
  //expect 4 + 3i
  printComplex(cpx1);
  complex<int> add = 3 + cpx2;
  //expect 4 + 3i
  printComplex(add);
  complex<int> add2 = cpx2 + 3;
  //expect 4 + 3i
  printComplex(add2);
  complex<int> add3 = cpx1 + cpx2;
  //expect 5 + 6i
  printComplex(add3);
  //test (*) operator
  complex<int> z1(3, 2);
  complex<int> z2(1, 1);
  //expect 6 + 4i
  printComplex(2 * z1);
  //expect 6 + 4i
  printComplex(z1 * 2);
  //expect 1 + 5i
  printComplex(z1 * z2);
  return 0;
}
